{{
Jazzed_JVM_Opcodes_001.spin
}}
OBJ
  jem: "Jazzed_JVM_JemCodes_001" ' jemcodes file
  
PUB OpcodeNamePtr( opcode )

  if opcode < jem#Jem_INSTANCEOF
  
    case opcode
      jem#Jem_NOP:             result := String("NOP")
      jem#Jem_ICONST_M1:       result := String("ICONST_M1")
      jem#Jem_ICONST_0:        result := String("ICONST_0")
      jem#Jem_ICONST_1:        result := String("ICONST_1")
      jem#Jem_ICONST_2:        result := String("ICONST_2")
      jem#Jem_ICONST_3:        result := String("ICONST_3")
      jem#Jem_ICONST_4:        result := String("ICONST_4")
      jem#Jem_ICONST_5:        result := String("ICONST_5")
      jem#Jem_BIPUSH:          result := String("BIPUSH")
      jem#Jem_SIPUSH:          result := String("SIPUSH")
      jem#Jem_ILOAD:           result := String("ILOAD")
      jem#Jem_ILOAD_0:         result := String("ILOAD_0")
      jem#Jem_ILOAD_1:         result := String("ILOAD_1")
      jem#Jem_ILOAD_2:         result := String("ILOAD_2")
      jem#Jem_ILOAD_3:         result := String("ILOAD_3")
      jem#Jem_ISTORE:          result := String("ISTORE")
      jem#Jem_ISTORE_0:        result := String("ISTORE_0")
      jem#Jem_ISTORE_1:        result := String("ISTORE_1")
      jem#Jem_ISTORE_2:        result := String("ISTORE_2")
      jem#Jem_ISTORE_3:        result := String("ISTORE_3")
      jem#Jem_IFEQ:            result := String("IFEQ")
      jem#Jem_IFNE:            result := String("IFNE")
      jem#Jem_IFLT:            result := String("IFLT")
      jem#Jem_IFLE:            result := String("IFLE")
      jem#Jem_IFGT:            result := String("IFGT")
      jem#Jem_IFGE:            result := String("IFGE")
      jem#Jem_IF_ICMPEQ:       result := String("IF_ICMPEQ")
      jem#Jem_IF_ICMPNE:       result := String("IF_ICMPNE")
      jem#Jem_IF_ICMPLT:       result := String("IF_ICMPLT")
      jem#Jem_IF_ICMPGE:       result := String("IF_ICMPGE")
      jem#Jem_IF_ICMPGT:       result := String("IF_ICMPGT")
      jem#Jem_IF_ICMPLE:       result := String("IF_ICMPLE")
      jem#Jem_IF_ACMPEQ:       result := String("IF_ACMPEQ")
      jem#Jem_IF_ACMPNE:       result := String("IF_ACMPNE")
      jem#Jem_IRETURN:         result := String("IRETURN")
      jem#Jem_RETURN:          result := String("RETURN")
      jem#Jem_INVOKEVIRTUAL:   result := String("INVOKEVIRTUAL")
      jem#Jem_INVOKESTATIC:    result := String("INVOKESTATIC")
      jem#Jem_GETSTATIC:       result := String("GETSTATIC")
      jem#Jem_PUTSTATIC:       result := String("PUTSTATIC")
      jem#Jem_POP:             result := String("POP")
      jem#Jem_POP2:            result := String("POP2")
      jem#Jem_DUP:             result := String("DUP")
      jem#Jem_DUP_X1:          result := String("DUP_X1")
      jem#Jem_DUP_X2:          result := String("DUP_X2")
      jem#Jem_DUP2:            result := String("DUP2")
      jem#Jem_DUP2_X1:         result := String("DUP2_X1")
      jem#Jem_DUP2_X2:         result := String("DUP2_X2")
      jem#Jem_SWAP:            result := String("SWAP")
      jem#Jem_IADD:            result := String("IADD")
      jem#Jem_ISUB:            result := String("ISUB")
      jem#Jem_INEG:            result := String("INEG")
      jem#Jem_IOR:             result := String("IOR")
      jem#Jem_ISHL:            result := String("ISHL")
      jem#Jem_ISHR:            result := String("ISHR")
      jem#Jem_IUSHR:           result := String("IUSHR")
      jem#Jem_IAND:            result := String("IAND")
      jem#Jem_IXOR:            result := String("IXOR")
      jem#Jem_I2B:             result := String("I2B")
      jem#Jem_GOTO:            result := String("GOTO")
      jem#Jem_INVOKEINTERFACE: result := String("INVOKEINTERFACE")
      jem#Jem_ARRAYLENGTH:     result := String("ARRAYLENGTH")
      jem#Jem_ATHROW:          result := String("ATHROW")
      jem#Jem_CHECKCAST:       result := String("CHECKCAST")

  else
    case opcode
    
      jem#Jem_INSTANCEOF:      result := String("INSTANCEOF")
      jem#Jem_WIDE:            result := String("WIDE")
      jem#Jem_IINC:            result := String("IINC")
      jem#Jem_GETFIELD:        result := String("GETFIELD")
      jem#Jem_PUTFIELD:        result := String("PUTFIELD")
      jem#Jem_NEW:             result := String("NEW")
      jem#Jem_NEWARRAY:        result := String("NEWARRAY")
      jem#Jem_ANEWARRAY:       result := String("ANEWARRAY")
      jem#Jem_IALOAD:          result := String("IALOAD")
      jem#Jem_IASTORE:         result := String("IASTORE")
      jem#Jem_BALOAD:          result := String("BALOAD")
      jem#Jem_BASTORE:         result := String("BASTORE")
      jem#Jem_LDC:             result := String("LDC")
      jem#Jem_LDC_W:           result := String("LDC_W")
      jem#Jem_LDC2_W:          result := String("LDC2_W")
      jem#Jem_IMUL:            result := String("IMUL")
      jem#Jem_IDIV:            result := String("IDIV")
      jem#Jem_IREM:            result := String("IREM")
      jem#Jem_JSR:             result := String("JSR")
      jem#Jem_RET:             result := String("RET")
      jem#Jem_TABLESWITCH:     result := String("TABLESWITCH")
      jem#Jem_LOOKUPSWITCH:    result := String("LOOKUPSWITCH")
      other:                   result := String("Unknown")


PUB getOperandSize(opcode)
{{
/**
 * get size of operand for opcode. used in primitive bytecode disassembler.
 * @param opcode - this is the opcode used for operand size lookup.
 * @returns number of bytes in operand.
 */
 _ int getOperandSize(int opcode);
}}


  ' geez only 64 cases allowed
  '
  if opcode < jem#Jem_INSTANCEOF

    case opcode

      jem#Jem_NOP               : result := 0
      jem#Jem_ICONST_M1         : result := 0 ' check it
      jem#Jem_ICONST_0          : result := 0 ' check it
      jem#Jem_ICONST_1          : result := 0 ' check it
      jem#Jem_ICONST_2          : result := 0 ' check it
      jem#Jem_ICONST_3          : result := 0 ' check it
      jem#Jem_ICONST_4          : result := 0 ' check it
      jem#Jem_ICONST_5          : result := 0 ' check it
      jem#Jem_BIPUSH            : result := 1
      jem#Jem_SIPUSH            : result := 2
      jem#Jem_ILOAD             : result := 1
      jem#Jem_ILOAD_0           : result := 0 ' check it
      jem#Jem_ILOAD_1           : result := 0 ' check it
      jem#Jem_ILOAD_2           : result := 0 ' check it
      jem#Jem_ILOAD_3           : result := 0 ' check it
      jem#Jem_ISTORE            : result := 1
      jem#Jem_ISTORE_0          : result := 0 ' check it
      jem#Jem_ISTORE_1          : result := 0 ' check it
      jem#Jem_ISTORE_2          : result := 0 ' check it
      jem#Jem_ISTORE_3          : result := 0 ' check it
      jem#Jem_IFEQ              : result := 0
      jem#Jem_IFNE              : result := 0
      jem#Jem_IFLT              : result := 0
      jem#Jem_IFLE              : result := 0
      jem#Jem_IFGT              : result := 0
      jem#Jem_IFGE              : result := 0
      jem#Jem_IF_ICMPEQ         : result := 0
      jem#Jem_IF_ICMPNE         : result := 0
      jem#Jem_IF_ICMPLT         : result := 0
      jem#Jem_IF_ICMPGE         : result := 0
      jem#Jem_IF_ICMPGT         : result := 0
      jem#Jem_IF_ICMPLE         : result := 0
      jem#Jem_IF_ACMPEQ         : result := 0
      jem#Jem_IF_ACMPNE         : result := 0
      jem#Jem_IRETURN           : result := 0
      jem#Jem_RETURN            : result := 0
      jem#Jem_INVOKEVIRTUAL     : result := 2
      jem#Jem_INVOKESTATIC      : result := 2
      jem#Jem_GETSTATIC         : result := 2
      jem#Jem_PUTSTATIC         : result := 2
      jem#Jem_POP               : result := 0
      jem#Jem_POP2              : result := 0
      jem#Jem_DUP               : result := 0
      jem#Jem_DUP_X1            : result := 0
      jem#Jem_DUP_X2            : result := 0
      jem#Jem_DUP2              : result := 0
      jem#Jem_DUP2_X1           : result := 0
      jem#Jem_DUP2_X2           : result := 0
      jem#Jem_SWAP              : result := 0
      jem#Jem_IADD              : result := 0
      jem#Jem_ISUB              : result := 0
      jem#Jem_INEG              : result := 0
      jem#Jem_IOR               : result := 0
      jem#Jem_ISHL              : result := 0
      jem#Jem_ISHR              : result := 0
      jem#Jem_IUSHR             : result := 0
      jem#Jem_IAND              : result := 0
      jem#Jem_IXOR              : result := 0
      jem#Jem_I2B               : result := 0
      jem#Jem_GOTO              : result := 2
      jem#Jem_INVOKEINTERFACE   : result := 2 ' ?? not implemented yet .....
      jem#Jem_ARRAYLENGTH       : result := 0
      jem#Jem_ATHROW            : result := 0 ' ?? not implemented yet .....
      jem#Jem_CHECKCAST         : result := 2 ' ?? not implemented yet .....

  else

    case opcode

      jem#Jem_INSTANCEOF        : result := 2
      jem#Jem_WIDE              : result := 0 ' ?? not implemented yet .....
      jem#Jem_IINC              : result := 2
      jem#Jem_GETFIELD          : result := 2
      jem#Jem_PUTFIELD          : result := 2
      jem#Jem_NEW               : result := 2
      jem#Jem_NEWARRAY          : result := 2
      jem#Jem_ANEWARRAY         : result := 2
      jem#Jem_IALOAD            : result := 0
      jem#Jem_IASTORE           : result := 0
      jem#Jem_BALOAD            : result := 0
      jem#Jem_BASTORE           : result := 0
      jem#Jem_LDC               : result := 1
      jem#Jem_LDC_W             : result := 2
      jem#Jem_LDC2_W            : result := 2
      jem#Jem_IMUL              : result := 0
      jem#Jem_IDIV              : result := 0
      jem#Jem_IREM              : result := 0
      jem#Jem_JSR               : result := 2
      jem#Jem_RET               : result := 1
      jem#Jem_TABLESWITCH       : result := 1 ' ?? not implemented yet .....
      jem#Jem_LOOKUPSWITCH      : result := 1 ' ?? not implemented yet .....

  'return result ... automatic in spin
